routes/web.php
<?php

use App\Http\Controllers\Admin\DashboardController as AdminDashboardController;
use App\Http\Controllers\Admin\UserController as AdminUserController;
use App\Http\Controllers\Admin\StaffController as AdminStaffController;
use App\Http\Controllers\Admin\ProductController as AdminProductController;
use App\Http\Controllers\Admin\OrderController as AdminOrderController;
use App\Http\Controllers\User\DashboardController as UserDashboardController;
use App\Http\Controllers\User\OrderController as UserOrderController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes([
    'register' => false
]);

Route::prefix('admin')->name('admin.')->group(function(){
    // Admin Routes
    Route::middleware(['auth', 'role:admin'])->group(function(){
        Route::get('/', [AdminDashboardController::class, 'index'])->name('index');
    });

    // Admin & Staff Routes
    Route::middleware(['auth', 'role:admin,staff'])->group(function(){
        Route::prefix('user')->name('user.')->group(function(){
            Route::get('/', [AdminUserController::class, 'index'])->name('index');
            Route::get('/create', [AdminUserController::class, 'create'])->name('create');
            Route::post('/create', [AdminUserController::class, 'store'])->name('store');
            Route::get('/detail/{id}', [AdminUserController::class, 'detail'])->name('detail');
            Route::get('/edit/{id}', [AdminUserController::class, 'edit'])->name('edit');
            Route::put('/edit/{id}', [AdminUserController::class, 'update'])->name('update');
            Route::delete('/delete', [AdminUserController::class, 'delete'])->name('delete');
        });

        Route::prefix('staff')->name('staff.')->group(function(){
            Route::get('/', [AdminStaffController::class, 'index'])->name('index');
            Route::get('/create', [AdminStaffController::class, 'create'])->name('create');
            Route::post('/create', [AdminStaffController::class, 'store'])->name('store');
            Route::get('/detail/{id}', [AdminStaffController::class, 'detail'])->name('detail');
            Route::get('/edit/{id}', [AdminStaffController::class, 'edit'])->name('edit');
            Route::put('/edit/{id}', [AdminStaffController::class, 'update'])->name('update');
            Route::delete('/delete', [AdminStaffController::class, 'delete'])->name('delete');
        });

        Route::prefix('product')->name('product.')->group(function(){
            Route::get('/', [AdminProductController::class, 'index'])->name('index');
            Route::get('/create', [AdminProductController::class, 'create'])->name('create');
            Route::post('/create', [AdminProductController::class, 'store'])->name('store');
            Route::get('/detail/{id}', [AdminProductController::class, 'detail'])->name('detail');
            Route::get('/edit/{id}', [AdminProductController::class, 'edit'])->name('edit');
            Route::put('/edit/{id}', [AdminProductController::class, 'update'])->name('update');
            Route::delete('/delete', [AdminProductController::class, 'delete'])->name('delete');
        });

        Route::prefix('order')->name('order.')->group(function(){
            Route::get('/', [AdminOrderController::class, 'index'])->name('index');
            Route::get('/detail/{code}', [AdminOrderController::class, 'detail'])->name('detail');
            Route::post('/confirm', [AdminOrderController::class, 'confirm'])->name('confirm');
            Route::post('/reject', [AdminOrderController::class, 'reject'])->name('reject');
        });
    });
});

// User Routes
Route::middleware(['auth', 'role:user'])->group(function(){
    Route::get('/', [UserDashboardController::class, 'index'])->name('index');

    Route::prefix('order')->name('order.')->group(function(){
        Route::get('/', [UserOrderController::class, 'index'])->name('index');
        Route::get('/detail/{code}', [UserOrderController::class, 'detail'])->name('detail');
        Route::post('/add-to-cart', [UserOrderController::class, 'addToCart'])->name('addToCart');
        Route::get('/cart', [UserOrderController::class, 'cart'])->name('cart');
        Route::post('/checkout', [UserOrderController::class, 'checkout'])->name('checkout');
    });
});

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable, SoftDeletes;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
        'username',
        'role',
        'birthdate',
        'sex',
        'address',
        'ktp_image_url'
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function hasRole($role)
    {
        return (in_array($this->role, $role));
    }

    public function isAdmin()
    {
        return (in_array($this->role, ['admin']));
    }

    public function isStaff()
    {
        return (in_array($this->role, ['staff']));
    }

    public function isUser()
    {
        return (in_array($this->role, ['user']));
    }
}

app/Http/Controllers/Admin/UserController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Validator;

class UserController extends Controller
{
    public function index()
    {
        $users = User::where('role', 'user')->simplePaginate(10);

        return view('admins.users.index', [
            'users' => $users
        ]);
    }

    public function detail(Request $request)
    {
        $user = User::where('id', $request->id)->first();
        if (!$user) {
            abort('404', 'User not found');
        }

        return view('admins.users.detail', [
            'user' => $user
        ]);
    }

    public function create()
    {
        return view('admins.users.form');
    }
    
    public function store(Request $request)
    {
        $validate = Validator::make($request->all(), [
            "name" => ['required'],
            "birthdate" => ['required'],
            "address" => ['required'],
            "email" => ['required', 'unique:users,email'],
            "username" => ['required', 'unique:users,username'],
            "password" => ['required', 'confirmed'],
            "password_confirmation" => ['required'],
            "ktp_image_url" => ['file', 'required']
        ]);

        if ($validate->fails()) {
            return redirect()->route('admin.user.create')->withErrors($validate)->withInput();
        }

        DB::beginTransaction();
        try {
            $url = null;
            if ($request->file('ktp_image_url')) {
                $targetPath = 'images/user';
                $directory = public_path($targetPath);
                if (!File::exists($directory)) {
                    File::makeDirectory($directory, 0775, true);
                }
                
                $filename = strtotime(date('Y-m-d H:i:s')).'.'.$request->file('ktp_image_url')->getClientOriginalExtension();
    
                $request->file('ktp_image_url')->move($directory, $filename);
                $url = asset($targetPath.'/'.$filename);
            }
    
            $user = User::create([
                'email' => $request->email,
                'name' => $request->name,
                'birthdate' => $request->birthdate,
                'address' => $request->address,
                'username' => $request->username,
                'password' => Hash::make($request->password),
                'ktp_image_url' => $url
            ]);
            DB::commit();
    
            return redirect()->route('admin.user.create')->with('msg', 'User created successfully. <a href="'.route('admin.user.detail', $user->id).'">Lihat Detail</a>');
        } catch (\Throwable $th) {
            DB::rollBack();
            $validate->getMessageBag()->add('system', $th->getMessage());
            
            return redirect()->route('admin.user.create')->withErrors($validate)->withInput();
        }
    }

    public function edit(Request $request)
    {
        $user = User::where('id', $request->id)->first();
        if (!$user) {
            abort('404', 'User not found');
        }

        return view('admins.users.form', [
            'user' => $user
        ]);
    }

    public function update(Request $request)
    {
        $validate = Validator::make($request->all(), [
            "name" => ['required'],
            "birthdate" => ['required'],
            "address" => ['required'],
            "email" => ['required'],
            "username" => ['required'],
            "password" => ['confirmed'],
            "password_confirmation" => ['required_with:password']
        ]);

        if ($validate->fails()) {
            return redirect()->route('admin.user.edit', $request->id)->withErrors($validate)->withInput();
        }

        DB::beginTransaction();
        try {
            $user = User::where('id', $request->id)->first();
            if ($request->file('ktp_image_url')) {
                $targetPath = 'images/user';
                $directory = public_path($targetPath);
                if (!File::exists($directory)) {
                    File::makeDirectory($directory, 0775, true);
                }
                
                $filename = strtotime(date('Y-m-d H:i:s')).'.'.$request->file('ktp_image_url')->getClientOriginalExtension();
    
                $request->file('ktp_image_url')->move($directory, $filename);
                $url = asset($targetPath.'/'.$filename);

                $user->update([
                    'ktp_image_url' => $url
                ]);
            }

            if ($request->password) {
                $user->update([
                    'password' => Hash::make($request->password)
                ]);
            }
    
            $user->update([
                'email' => $request->email,
                'name' => $request->name,
                'birthdate' => $request->birthdate,
                'address' => $request->address,
                'username' => $request->username
            ]);
            DB::commit();
    
            return redirect()->route('admin.user.edit', $user->id)->with('msg', 'User updated successfully. <a href="'.route('admin.user.detail', $user->id).'">Lihat Detail</a>');
        } catch (\Throwable $th) {
            DB::rollBack();
            $validate->getMessageBag()->add('system', $th->getMessage());
            
            return redirect()->route('admin.user.edit', $request->id)->withErrors($validate)->withInput();
        }
    }

    public function delete(Request $request)
    {
        User::where('id', $request->id)->delete();

        return redirect()->route('admin.user.index')->with('msg', 'User deleted successfully.');
    }
}

app/Http/Controllers/User/DashboardController.php
<?php

namespace App\Http\Controllers\User;

use App\Http\Controllers\Controller;
use App\Models\Product;
use Illuminate\Http\Request;

class DashboardController extends Controller
{
    public function index()
    {
        $products = Product::simplePaginate(20);

        return view('home', [
            'products' => $products
        ]);
    }
}

app/Http/Controllers/User/OrderController.php
<?php

namespace App\Http\Controllers\User;

use App\Http\Controllers\Controller;
use App\Models\Cart;
use App\Models\OrderItem;
use App\Models\Order;
use Exception;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Str;

class OrderController extends Controller
{
    public function addToCart(Request $request)
    {
        $cart = Cart::where('user_id', auth()->user()->id)->where('product_id', $request->product_id)->first();

        Cart::updateOrCreate([
            'product_id' => $request->product_id,
            'user_id' => auth()->user()->id,
        ],[
            'qty' => $request->qty + ($cart->qty ?? 0)
        ]);

        return redirect()->back();
    }

    public function cart(Request $request)
    {
        $carts = Cart::has('product')->where('user_id', auth()->user()->id)->get();

        return view('cart', [
            'carts' => $carts
        ]);
    }

    public function checkout(Request $request)
    {
        DB::beginTransaction();
        try {
            $order = Order::create([
                'invoice_code' => strtoupper(Str::random(8)),
                'user_id' => auth()->user()->id,
                'total_price' => $request->total_price,
                'status' => 'waiting_confirmation'
            ]);
    
            $carts = Cart::where('user_id', auth()->user()->id)->get();
    
            foreach ($carts as $key => $cart) {
                if ($cart->qty > $cart->product->stock) {
                    throw new Exception("Stok tidak tersedia");
                }
                
                OrderItem::create([
                    'order_id' => $order->id,
                    'price' => $cart->product->selling_price,
                    'capital_price' => $cart->product->capital_price,
                    'product_id' => $cart->product_id,
                    'qty' => $cart->qty
                ]);
            }
    
            Cart::where('user_id', auth()->user()->id)->delete();
    
            DB::commit();

            return redirect()->route('order.detail', $order->invoice_code);
        } catch (\Throwable $th) {
            DB::rollBack();
            
            return redirect()->back();
        }
    }

    public function index(Request $request)
    {
        $orders = Order::with('items')->where('user_id', auth()->user()->id)->simplePaginate();

        return view('order', [
            'orders' => $orders
        ]);
    }
    
    public function detail(Request $request)
    {
        $order = Order::with('items')->where('user_id', auth()->user()->id)->where('invoice_code', $request->code)->first();

        return view('order-detail', [
            'order' => $order
        ]);
    }
}

resources/views/admins/users/detail.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('Detail User '.$user->name) }}</div>

                <div class="card-body">
                    @if ($errors->any())
                        <div class="alert alert-danger">
                            <ul class="m-0">
                                @foreach ($errors->all() as $error)
                                    <li>{{ $error }}</li>
                                @endforeach
                            </ul>
                        </div>
                    @endif

                    @if(session('msg'))
                    <div class="alert alert-info">
                        {{ session('msg') }}
                    </div>
                    @endif

                    <form method="POST" action="{{ route('admin.user.create') }}" enctype="multipart/form-data">
                        @csrf

                        <div class="row mb-3">
                            <label for="name" class="col-md-4 col-form-label text-md-end">{{ __('Name') }}</label>

                            <div class="col-md-6">
                                <input type="text" disabled required name="name" value="{{ $user->name ?? old('name') }}" class="form-control @error('name') is-invalid @enderror" />
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="birthdate" class="col-md-4 col-form-label text-md-end">{{ __('Birth Date') }}</label>

                            <div class="col-md-6">
                                <input type="date" disabled required name="birthdate" value="{{ $user->birthdate ?? old('birthdate') }}" class="form-control @error('birthdate') is-invalid @enderror" />
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="address" class="col-md-4 col-form-label text-md-end">{{ __('Address') }}</label>

                            <div class="col-md-6">
                                <textarea name="address" class="form-control @error('address') is-invalid @enderror">{{ $user->address ?? old('address') }}</textarea>
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="ktp" class="col-md-4 col-form-label text-md-end">{{ __('KTP') }}</label>

                            <div class="col-md-6">
                                <img src="{{ $user->ktp_image_url }}" class="img-fluid" />
                            </div>
                        </div>

                        <hr>

                        <div class="row mb-3">
                            <label for="email" class="col-md-4 col-form-label text-md-end">{{ __('Email') }}</label>

                            <div class="col-md-6">
                                <input type="email" disabled required name="email" value="{{ $user->email ?? old('email') }}" class="form-control @error('email') is-invalid @enderror" />
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="username" class="col-md-4 col-form-label text-md-end">{{ __('Username') }}</label>

                            <div class="col-md-6">
                                <input type="text" disabled required name="username" value="{{ $user->username ?? old('username') }}" class="form-control @error('username') is-invalid @enderror" />
                            </div>
                        </div>

                        <div class="row mb-0">
                            <div class="col-md-8 offset-md-4">
                                <a class="btn btn-secondary" href="{{ route('admin.user.index') }}">Cancel</a>
                                <a class="btn btn-warning" href="{{ route('admin.user.edit', $user->id) }}">Edit</a>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/admins/users/form.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                @if(\Request::route()->getName() == 'admin.user.create')
                <div class="card-header">{{ __('Create User') }}</div>
                @else
                <div class="card-header">{{ __('Edit User '.$user->name) }}</div>
                @endif

                <div class="card-body">
                    @if ($errors->any())
                        <div class="alert alert-danger">
                            <ul class="m-0">
                                @foreach ($errors->all() as $error)
                                    <li>{{ $error }}</li>
                                @endforeach
                            </ul>
                        </div>
                    @endif

                    @if(session('msg'))
                    <div class="alert alert-info">
                        {!! session('msg') !!}
                    </div>
                    @endif

                    @if(\Request::route()->getName() == 'admin.user.create')
                    <form method="POST" action="{{ route('admin.user.create') }}" enctype="multipart/form-data">
                    @else
                    <form method="POST" action="{{ route('admin.user.edit', $user->id) }}" enctype="multipart/form-data">
                        @method('PUT')
                    @endif

                        @csrf

                        <div class="row mb-3">
                            <label for="name" class="col-md-4 col-form-label text-md-end">{{ __('Name') }}</label>

                            <div class="col-md-6">
                                <input type="text" required name="name" value="{{ old('name') ?? ($user->name ?? null) }}" class="form-control @error('name') is-invalid @enderror" />
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="birthdate" class="col-md-4 col-form-label text-md-end">{{ __('Birth Date') }}</label>

                            <div class="col-md-6">
                                <input type="date" required name="birthdate" value="{{ old('birthdate') ?? ($user->birthdate ?? null) }}" class="form-control @error('birthdate') is-invalid @enderror" />
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="address" class="col-md-4 col-form-label text-md-end">{{ __('Address') }}</label>

                            <div class="col-md-6">
                                <textarea name="address" class="form-control @error('address') is-invalid @enderror">{{ old('address') ?? ($user->address ?? null) }}</textarea>
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="ktp" class="col-md-4 col-form-label text-md-end">{{ __('KTP') }}</label>

                            <div class="col-md-6">
                                <input type="file" class="form-control @error('ktp_image_url') is-invalid @enderror" name="ktp_image_url" <?=(\Request::route()->getName() == 'admin.user.create' ? 'required' : null)?> accept="image/png, image/jpeg, image/jpg" />
                                <img src="{{ $user->ktp_image_url ?? null }}" class="img-fluid my-2" />
                            </div>
                        </div>

                        <hr>

                        <div class="row mb-3">
                            <label for="email" class="col-md-4 col-form-label text-md-end">{{ __('Email') }}</label>

                            <div class="col-md-6">
                                <input type="email" required name="email" value="{{ old('email') ?? ($user->email ?? null) }}" class="form-control @error('email') is-invalid @enderror" />
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="username" class="col-md-4 col-form-label text-md-end">{{ __('Username') }}</label>

                            <div class="col-md-6">
                                <input type="text" required name="username" value="{{ old('username') ?? ($user->username ?? null) }}" class="form-control @error('username') is-invalid @enderror" />
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="password" class="col-md-4 col-form-label text-md-end">{{ __('Password') }}</label>

                            <div class="col-md-6">
                                <input id="password" type="password" class="form-control @error('password') is-invalid @enderror" <?=(\Request::route()->getName() == 'admin.user.create' ? 'required' : null)?> name="password" autocomplete="current-password">
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="password_confirmation" class="col-md-4 col-form-label text-md-end">{{ __('Retype Password') }}</label>

                            <div class="col-md-6">
                                <input id="password_confirmation" type="password" class="form-control @error('password_confirmation') is-invalid @enderror" <?=(\Request::route()->getName() == 'admin.user.create' ? 'required' : null)?> name="password_confirmation" autocomplete="current-password">
                            </div>
                        </div>

                        <div class="row mb-0">
                            <div class="col-md-8 offset-md-4">
                                <a class="btn btn-secondary" href="{{ route('admin.user.index') }}">Cancel</a>
                                @if(\Request::route()->getName() == 'admin.user.create')
                                <button type="submit" class="btn btn-primary">
                                    {{ __('Submit') }}
                                </button>
                                @else
                                <button type="submit" class="btn btn-warning">
                                    {{ __('Update') }}
                                </button>
                                @endif
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/admins/users/index.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header d-flex align-items-center">
                    <div>User Data</div> <a href="{{ route('admin.user.create') }}" class="ms-auto btn btn-primary">Create</a>
                </div>
                <div class="card-body">
                    @if(session('msg'))
                    <div class="alert alert-info">
                        {!! session('msg') !!}
                    </div>
                    @endif

                    <table class="table table-hover">
                        <thead>
                            <tr>
                                <th class="text-center">No</th>
                                <th>Name</th>
                                <th>Email</th>
                                <th>Username</th>
                                <th class="text-center">Action</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach($users as $key => $user)
                            <tr>
                                <td class="text-center">{{ $users->firstItem() + $key }}</td>
                                <td>{{ $user->name }}</td>
                                <td>{{ $user->email }}</td>
                                <td>{{ $user->username }}</td>
                                <td class="text-center">
                                    <a class="btn btn-sm btn-primary" href="{{ route('admin.user.detail', $user->id) }}">Detail</a>
                                    @if(auth()->user()->isAdmin())
                                    <a class="btn btn-sm btn-warning" href="{{ route('admin.user.edit', $user->id) }}">Edit</a>
                                    <a class="btn btn-sm btn-danger" onclick="event.preventDefault(); if(confirm('Are you sure want to delete this?')) document.getElementById('delete-form-{{ $user->id }}').submit();" href="">Delete</a>
                                    <form action="{{ route('admin.user.delete') }}" method="POST" id="delete-form-{{ $user->id }}" style="display: none;">
                                        @method('DELETE')
                                        @csrf
                                        <input type="hidden" value="{{ $user->id }}" name="id">
                                    </form>
                                    @endif
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                    </table>
    
                    {{ $users->links() }}
                </div>
            </div>
        </div>
    </div>
</div>
@endsection